#include <stdio.h>
#include <math.h>

#define N 20

typedef struct {float x, v; } stato;

stato prossimo(stato s, float h) {
    float rho = 1.25; // Densita' dell'aria
    float a = 2.5 * 1.2;	  // Superficie della seziojne
    float c_d = 0.82; // Coefficiente di trascinamento
    float m = 1539;	// Massa dell'auto
    float f = 10000;	// Forza di accelerazione

    // Preparo una struttura per il risultato
    stato r;
    // Calcolo la posizione futura
    r.x = s.x + h * s.v;
    // Calcolo la forza di trascinamento
    float ftr = 0.5 * rho * c_d * a * s.v * fabs(s.v);
    // Calcolo la velocità futura
    r.v = s.v + h * (f + ftr) / m;
    // Restituisco il risultato
    return r;
}


int main() {
    stato stati[N];

    // Definisco lo stato iniziale
    stati[0].x = 0;
    stati[0].v = 0;

    // Simulo
    for(int i = 1; i < N; ++i) {
        stati[i] = prossimo(stati[i-1], 0.1);
    }

    // Stampo lo stato nel tempo
    for(int i = 0; i < N; ++i)
        printf("%.2f\t%.2f\n", stati[i].x, stati[i].v);
}
