#include <stdio.h>
#include <string.h>

#define N 16
#define NMAT 4
#define NNOME 64

typedef struct {char mat[NMAT], nome[NNOME]; int voto; } stud;

void leggi_studente(stud *s) {
    printf("matricola (%d caratteri): ", NMAT-1);
    scanf("%s", s->mat);
    printf("nome: ");
    scanf("%s", s->nome);
    printf("voto: ");
    scanf("%d", &s->voto);
}

void stampa_studente(stud d) {
    printf("%s %s %d\n", d.mat, d.nome, d.voto);
}

void stampa_studenti(stud *lista, int n) {
    printf("\nLISTA\n");
    for(int i = 0; i < n; ++i)
        stampa_studente(lista[i]);
    printf("\n");
}

void inserisci_in_coda(stud s, stud *lista, int *n) {
    // Effettuo l'inserimento
    lista[*n] = s;
    // Incremento la dimensione
    *n += 1;
}

void inserisci_in_testa(stud s, stud *lista, int *n) {
    // Faccio "scorrere" in avanti l'array
    for(int i = *n; i > 0; --i)
        lista[i] = lista[i-1];
    // Effettuo l'inserimento
    lista[0] = s;
    // Incremento la dimensione
    *n += 1;
}

int trova_voto(char *mat, stud *lista, int n) {
    for(int i = 0; i < n; ++i) {
        if (strcmp(mat, lista[i].mat) == 0)
            return lista[i].voto;
    }
    return -1;
}

int main() {
    stud lista[N];
    int nlista = 0;
    stud s;
    
    // Prima parte: lettura e scrittura
    printf("PRIMO STUDENTE\n");
    leggi_studente(&s);
    stampa_studente(s);

    // Seconda parte: inserimento in coda e stampa
    inserisci_in_coda(s, lista, &nlista);
    stampa_studenti(lista, nlista);

    // Terza parte: inserimento in coda
    printf("SECONDO STUDENTE (inserimento in coda)\n");
    leggi_studente(&s);
    inserisci_in_coda(s, lista, &nlista);
    stampa_studenti(lista, nlista);

    // Quarta parte: inserimento in testa
    printf("TERZO STUDENTE (inserimento in testa)\n");
    leggi_studente(&s);
    inserisci_in_testa(s, lista, &nlista);
    stampa_studenti(lista, nlista);

    // Quinta parte: trovare un voto
    char matricola[NMAT];
    printf("Ricerca di un voto\n");
    printf("Matricola: ");
    scanf("%s", matricola);
    int voto = trova_voto(matricola, lista, nlista);
    if (voto < 0) printf("Matricola non trovata\n");
    else printf("Voto: %d\n", voto);
}
